#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %cgiparams;
# Maps a nice printable name to the changing part of the pid file, which
# is also the name of the program
my %servicenames =
(
	'DHCP server' => 'dhcpd',
	'Web server' => 'httpd',
	'CRON server' => 'crond',
	'Inet server' => 'inetd', 
	'DNS proxy server' => 'dnrd',
	'Logging server' => 'syslogd',
	'Kernel logging server' => 'klogd'
);

print "Content-type: text/html\n\n";

&getcgihash(\%cgiparams);

&openpage('Status information');

&openbigbox('100%', 'LEFT');

&openbox('100%', 'LEFT', 'Services:');

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='60%'>
END
;

foreach $key (keys %servicenames)
{
	print "<TR>\n";
	print "<TD ALIGN='CENTER'>$key</TD>\n";
	$shortname = $servicenames{$key};
	$status = &isrunning($shortname);
	print "<TD ALIGN='CENTER'>$status</TD>\n";
	print "</TR>\n";
}


print "</TABLE>\n";

&closebox();

&openbox('100%', 'LEFT', 'Memory:');
print "<PRE>\n";
system '/usr/bin/free';
print "</FRE>\n";
&closebox();

&openbox('100%', 'LEFT', 'Uptime and users:');
print "<PRE>\n";
system '/usr/bin/w';
print "</PRE>\n";
&closebox();

&openbox('100%', 'LEFT', 'Interfaces:');
print "<PRE>\n";
system '/sbin/ifconfig';
print "</PRE>\n";
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='60%'>
<TR>
	<TD ALIGN='CENTER'><A HREF='/cgi-bin/index.cgi'>BACK</A></TD>
	<TD ALIGN='CENTER'><A HREF='/configure.html#2.1.'>HELP</A></TD>
</TR>
</TABLE>
</DIV>
END
;

&closebigbox();

&closepage();

sub isrunning
{
	my $cmd = $_[0];
	my $status = "<FONT COLOR='red'>STOPPED</FONT>";
	my $pid = '';
	my $testcmd = '';

	if (open(FILE, "/var/run/${cmd}.pid"))
	{
 		$pid = <FILE>; chop $pid;
		close FILE;
		if (open(FILE, "/proc/${pid}/status"))
		{
			while (<FILE>)
			{
				if (/^Name:\W+(.*)/) {
					$testcmd = $1; }
			}
			close FILE;
			if ($testcmd eq $cmd)
			{
				$status = "<FONT COLOR='green'>RUNNING</FONT>";
				if (open(FILE, "/proc/${pid}/cmdline"))
				{
					$cmdline = <FILE>;
					if (!$cmdline) {
						$status = "$status (SWAPPED)"; }
				}
			}
		}
	}

	return $status;
}